diff -pruN 4.2.9-3/debian/changelog 4.2.9-4/debian/changelog
--- 4.2.9-3/debian/changelog	2013-12-29 18:58:02.000000000 +0000
+++ 4.2.9-4/debian/changelog	2015-02-08 02:00:46.000000000 +0000
@@ -1,3 +1,13 @@
+ruby-redcloth (4.2.9-4) unstable; urgency=high
+
+  * Team upload.
+  * debian/ruby-tests.rb → debian/ruby-tests.rake: fix recipe to run tests
+    during build.
+  * 0001-Filter-out-javascript-links-when-using-filter_html-o.patch:
+    - block javascript: links Closes: #774748 [CVE-2012-6684]
+
+ -- Antonio Terceiro <terceiro@debian.org>  Sat, 07 Feb 2015 23:30:26 -0200
+
 ruby-redcloth (4.2.9-3) unstable; urgency=medium
 
   * Team upload.
diff -pruN 4.2.9-3/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch 4.2.9-4/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch
--- 4.2.9-3/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch	1970-01-01 00:00:00.000000000 +0000
+++ 4.2.9-4/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch	2015-02-08 02:00:46.000000000 +0000
@@ -0,0 +1,53 @@
+From b3d82f0c3a354a2f589e1fd43f5f1d7e427b530e Mon Sep 17 00:00:00 2001
+From: Antonio Terceiro <terceiro@debian.org>
+Date: Sat, 7 Feb 2015 23:27:39 -0200
+Subject: [PATCH] Filter out 'javascript:' links when using filter_html or
+ sanitize_html
+
+This is a fix for CVE-2012-6684
+---
+ lib/redcloth/formatters/html.rb     |  6 +++++-
+ spec/security/CVE-2012-6684_spec.rb | 14 ++++++++++++++
+ 2 files changed, 19 insertions(+), 1 deletion(-)
+ create mode 100644 spec/security/CVE-2012-6684_spec.rb
+
+diff --git a/lib/redcloth/formatters/html.rb b/lib/redcloth/formatters/html.rb
+index bfadfb7..b8793b2 100644
+--- a/lib/redcloth/formatters/html.rb
++++ b/lib/redcloth/formatters/html.rb
+@@ -111,7 +111,11 @@ module RedCloth::Formatters::HTML
+   end
+   
+   def link(opts)
+-    "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
++    if (filter_html || sanitize_html) && opts[:href] =~ /^\s*javascript:/
++      opts[:name]
++    else
++      "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
++    end
+   end
+   
+   def image(opts)
+diff --git a/spec/security/CVE-2012-6684_spec.rb b/spec/security/CVE-2012-6684_spec.rb
+new file mode 100644
+index 0000000..05219fd
+--- /dev/null
++++ b/spec/security/CVE-2012-6684_spec.rb
+@@ -0,0 +1,14 @@
++# https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2012-6684
++
++require 'redcloth'
++
++describe 'CVE-2012-6684' do
++
++  it 'should not let javascript links pass through' do
++    # PoC from http://co3k.org/blog/redcloth-unfixed-xss-en
++    output = RedCloth.new('["clickme":javascript:alert(%27XSS%27)]', [:filter_html, :filter_styles, :filter_classes, :filter_ids]).to_html
++    expect(output).to_not match(/href=.javascript:alert/)
++  end
++
++
++end
+-- 
+2.1.4
+
diff -pruN 4.2.9-3/debian/patches/series 4.2.9-4/debian/patches/series
--- 4.2.9-3/debian/patches/series	2013-04-15 18:00:33.000000000 +0000
+++ 4.2.9-4/debian/patches/series	2015-02-08 02:00:46.000000000 +0000
@@ -1 +1,2 @@
 0001-restore-extconf.rb.patch
+0001-Filter-out-javascript-links-when-using-filter_html-o.patch
diff -pruN 4.2.9-3/debian/ruby-tests.rake 4.2.9-4/debian/ruby-tests.rake
--- 4.2.9-3/debian/ruby-tests.rake	1970-01-01 00:00:00.000000000 +0000
+++ 4.2.9-4/debian/ruby-tests.rake	2015-02-08 02:00:46.000000000 +0000
@@ -0,0 +1,7 @@
+require 'rspec/core/rake_task'
+
+RSpec::Core::RakeTask.new(:spec) do |spec|
+  spec.pattern = './spec/**/*_spec.rb'
+end
+
+task :default => :spec
diff -pruN 4.2.9-3/debian/ruby-tests.rb 4.2.9-4/debian/ruby-tests.rb
--- 4.2.9-3/debian/ruby-tests.rb	2013-04-15 18:00:33.000000000 +0000
+++ 4.2.9-4/debian/ruby-tests.rb	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-$: << 'spec'
-require 'rspec/core'
-Dir['spec/**/*_spec.rb'].each { |f| require f }
diff -pruN 4.2.9-3/lib/redcloth/formatters/html.rb 4.2.9-4/lib/redcloth/formatters/html.rb
--- 4.2.9-3/lib/redcloth/formatters/html.rb	2012-01-08 16:31:44.000000000 +0000
+++ 4.2.9-4/lib/redcloth/formatters/html.rb	2015-02-21 22:06:28.000000000 +0000
@@ -111,7 +111,11 @@ module RedCloth::Formatters::HTML
   end
   
   def link(opts)
-    "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
+    if (filter_html || sanitize_html) && opts[:href] =~ /^\s*javascript:/
+      opts[:name]
+    else
+      "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
+    end
   end
   
   def image(opts)
diff -pruN 4.2.9-3/.pc/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/lib/redcloth/formatters/html.rb 4.2.9-4/.pc/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/lib/redcloth/formatters/html.rb
--- 4.2.9-3/.pc/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/lib/redcloth/formatters/html.rb	1970-01-01 00:00:00.000000000 +0000
+++ 4.2.9-4/.pc/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/lib/redcloth/formatters/html.rb	2012-01-08 16:31:44.000000000 +0000
@@ -0,0 +1,345 @@
+module RedCloth::Formatters::HTML
+  include RedCloth::Formatters::Base
+  
+  [:h1, :h2, :h3, :h4, :h5, :h6, :p, :pre, :div].each do |m|
+    define_method(m) do |opts|
+      "<#{m}#{pba(opts)}>#{opts[:text]}</#{m}>\n"
+    end
+  end
+  
+  [:strong, :code, :em, :i, :b, :ins, :sup, :sub, :span, :cite].each do |m|
+    define_method(m) do |opts|
+      opts[:block] = true
+      "<#{m}#{pba(opts)}>#{opts[:text]}</#{m}>"
+    end
+  end
+  
+  def hr(opts)
+    "<hr#{pba(opts)} />\n"
+  end
+  
+  def acronym(opts)
+    opts[:block] = true
+    "<acronym#{pba(opts)}>#{caps(:text => opts[:text])}</acronym>"
+  end
+  
+  def caps(opts)
+    if no_span_caps
+      opts[:text]
+    else
+      opts[:class] = 'caps'
+      span(opts)
+    end
+  end
+  
+  def del(opts)
+    opts[:block] = true
+    "<del#{pba(opts)}>#{opts[:text]}</del>"
+  end
+  
+  [:ol, :ul].each do |m|
+    define_method("#{m}_open") do |opts|
+      opts[:block] = true
+      "#{"\n" if opts[:nest] > 1}#{"\t" * (opts[:nest] - 1)}<#{m}#{pba(opts)}>\n"
+    end
+    define_method("#{m}_close") do |opts|
+      "#{"\t" * (opts[:nest] - 1)}</#{m}>#{"\n" if opts[:nest] <= 1}"
+    end
+  end
+  
+  def li_open(opts)
+    "#{"\t" * opts[:nest]}<li#{pba(opts)}>#{opts[:text]}"
+  end
+  
+  def li_close(opts=nil)
+    "</li>\n"
+  end
+  
+  def dl_open(opts)
+    opts[:block] = true
+    "<dl#{pba(opts)}>\n"
+  end
+  
+  def dl_close(opts=nil)
+    "</dl>\n"
+  end
+  
+  [:dt, :dd].each do |m|
+    define_method(m) do |opts|
+      "\t<#{m}#{pba(opts)}>#{opts[:text]}</#{m}>\n"
+    end
+  end
+  
+  def td(opts)
+    tdtype = opts[:th] ? 'th' : 'td'
+    "\t\t<#{tdtype}#{pba(opts)}>#{opts[:text]}</#{tdtype}>\n"
+  end
+  
+  def tr_open(opts)
+    "\t<tr#{pba(opts)}>\n"
+  end
+  
+  def tr_close(opts)
+    "\t</tr>\n"
+  end
+  
+  def table_open(opts)
+    "<table#{pba(opts)}>\n"
+  end
+  
+  def table_close(opts)
+    "</table>\n"
+  end
+  
+  def bc_open(opts)
+    opts[:block] = true
+    "<pre#{pba(opts)}>"
+  end
+  
+  def bc_close(opts)
+    "</pre>\n"
+  end
+  
+  def bq_open(opts)
+    opts[:block] = true
+    cite = opts[:cite] ? " cite=\"#{ escape_attribute opts[:cite] }\"" : ''
+    "<blockquote#{cite}#{pba(opts)}>\n"
+  end
+  
+  def bq_close(opts)
+    "</blockquote>\n"
+  end
+  
+  def link(opts)
+    "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
+  end
+  
+  def image(opts)
+    opts.delete(:align)
+    opts[:alt] = opts[:title]
+    img = "<img src=\"#{escape_attribute opts[:src]}\"#{pba(opts)} alt=\"#{escape_attribute opts[:alt].to_s}\" />"  
+    img = "<a href=\"#{escape_attribute opts[:href]}\">#{img}</a>" if opts[:href]
+    img
+  end
+  
+  def footno(opts)
+    opts[:id] ||= opts[:text]
+    %Q{<sup class="footnote" id=\"fnr#{opts[:id]}\"><a href=\"#fn#{opts[:id]}\">#{opts[:text]}</a></sup>}
+  end
+  
+  def fn(opts)
+    no = opts[:id]
+    opts[:id] = "fn#{no}"
+    opts[:class] = ["footnote", opts[:class]].compact.join(" ")
+    "<p#{pba(opts)}><a href=\"#fnr#{no}\"><sup>#{no}</sup></a> #{opts[:text]}</p>\n"
+  end
+  
+  def snip(opts)
+    "<pre#{pba(opts)}><code>#{opts[:text]}</code></pre>\n"
+  end
+  
+  def quote1(opts)
+    "&#8216;#{opts[:text]}&#8217;"
+  end
+  
+  def quote2(opts)
+    "&#8220;#{opts[:text]}&#8221;"
+  end
+  
+  def multi_paragraph_quote(opts)
+    "&#8220;#{opts[:text]}"
+  end
+  
+  def ellipsis(opts)
+    "#{opts[:text]}&#8230;"
+  end
+  
+  def emdash(opts)
+    "&#8212;"
+  end
+  
+  def endash(opts)
+    " &#8211; "
+  end
+  
+  def arrow(opts)
+    "&#8594;"
+  end
+  
+  def dim(opts)
+    opts[:text].gsub!('x', '&#215;')
+    opts[:text].gsub!("'", '&#8242;')
+    opts[:text].gsub!('"', '&#8243;')
+    opts[:text]
+  end
+  
+  def trademark(opts)
+    "&#8482;"
+  end
+  
+  def registered(opts)
+    "&#174;"
+  end
+  
+  def copyright(opts)
+    "&#169;"
+  end
+  
+  def entity(opts)
+    "&#{opts[:text]};"
+  end
+  
+  def amp(opts)
+    "&amp;"
+  end
+  
+  def gt(opts)
+    "&gt;"
+  end
+  
+  def lt(opts)
+    "&lt;"
+  end
+  
+  def br(opts)
+    if hard_breaks == false
+      "\n"
+    else
+      "<br#{pba(opts)} />\n"
+    end
+  end
+  
+  def quot(opts)
+    "&quot;"
+  end
+  
+  def squot(opts)
+    "&#8217;"
+  end
+  
+  def apos(opts)
+    "&#39;"
+  end
+  
+  def html(opts)
+    "#{opts[:text]}\n"
+  end
+  
+  def html_block(opts)
+    inline_html(:text => "#{opts[:indent_before_start]}#{opts[:start_tag]}#{opts[:indent_after_start]}") + 
+    "#{opts[:text]}" +
+    inline_html(:text => "#{opts[:indent_before_end]}#{opts[:end_tag]}#{opts[:indent_after_end]}")
+  end
+  
+  def notextile(opts)
+    if filter_html
+      html_esc(opts[:text], :html_escape_preformatted)
+    else
+      opts[:text]
+    end
+  end
+  
+  def inline_html(opts)
+    if filter_html
+      html_esc(opts[:text], :html_escape_preformatted)
+    else
+      "#{opts[:text]}" # nil-safe
+    end
+  end
+  
+  def ignored_line(opts)
+    opts[:text] + "\n"
+  end
+  
+private
+  
+  # escapement for regular HTML (not in PRE tag)
+  def escape(text)
+    html_esc(text)
+  end
+
+  # escapement for HTML in a PRE tag
+  def escape_pre(text)
+    html_esc(text, :html_escape_preformatted)
+  end
+  
+  # escaping for HTML attributes
+  def escape_attribute(text)
+    html_esc(text, :html_escape_attributes)
+  end
+  
+  def after_transform(text)
+    text.chomp!
+  end
+  
+  
+  def before_transform(text)
+    clean_html(text) if sanitize_html
+  end
+  
+  # HTML cleansing stuff
+  BASIC_TAGS = {
+      'a' => ['href', 'title'],
+      'img' => ['src', 'alt', 'title'],
+      'br' => [],
+      'i' => nil,
+      'u' => nil, 
+      'b' => nil,
+      'pre' => nil,
+      'kbd' => nil,
+      'code' => ['lang'],
+      'cite' => nil,
+      'strong' => nil,
+      'em' => nil,
+      'ins' => nil,
+      'sup' => nil,
+      'sub' => nil,
+      'del' => nil,
+      'table' => nil,
+      'tr' => nil,
+      'td' => ['colspan', 'rowspan'],
+      'th' => nil,
+      'ol' => ['start'],
+      'ul' => nil,
+      'li' => nil,
+      'p' => nil,
+      'h1' => nil,
+      'h2' => nil,
+      'h3' => nil,
+      'h4' => nil,
+      'h5' => nil,
+      'h6' => nil, 
+      'blockquote' => ['cite'],
+      'notextile' => nil
+  }
+  
+  # Clean unauthorized tags.
+  def clean_html( text, allowed_tags = BASIC_TAGS )
+    text.gsub!( /<!\[CDATA\[/, '' )
+    text.gsub!( /<(\/*)([A-Za-z]\w*)([^>]*?)(\s?\/?)>/ ) do |m|
+      raw = $~
+      tag = raw[2].downcase
+      if allowed_tags.has_key? tag
+        pcs = [tag]
+        allowed_tags[tag].each do |prop|
+          ['"', "'", ''].each do |q|
+            q2 = ( q != '' ? q : '\s' )
+            if raw[3] =~ /#{prop}\s*=\s*#{q}([^#{q2}]+)#{q}/i
+              attrv = $1
+              next if (prop == 'src' or prop == 'href') and not attrv =~ %r{^(http|https|ftp):}
+              pcs << "#{prop}=\"#{attrv.gsub('"', '\\"')}\""
+              break
+            end
+          end
+        end if allowed_tags[tag]
+        "<#{raw[1]}#{pcs.join " "}#{raw[4]}>"
+      else # Unauthorized tag
+        if block_given?
+          yield m
+        else
+          ''
+        end
+      end
+    end
+  end
+end
diff -pruN 4.2.9-3/.pc/applied-patches 4.2.9-4/.pc/applied-patches
--- 4.2.9-3/.pc/applied-patches	2015-02-21 22:06:29.149848557 +0000
+++ 4.2.9-4/.pc/applied-patches	2015-02-21 22:06:28.653835094 +0000
@@ -1 +1,2 @@
 0001-restore-extconf.rb.patch
+0001-Filter-out-javascript-links-when-using-filter_html-o.patch
diff -pruN 4.2.9-3/spec/security/CVE-2012-6684_spec.rb 4.2.9-4/spec/security/CVE-2012-6684_spec.rb
--- 4.2.9-3/spec/security/CVE-2012-6684_spec.rb	1970-01-01 00:00:00.000000000 +0000
+++ 4.2.9-4/spec/security/CVE-2012-6684_spec.rb	2015-02-21 22:06:28.000000000 +0000
@@ -0,0 +1,14 @@
+# https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2012-6684
+
+require 'redcloth'
+
+describe 'CVE-2012-6684' do
+
+  it 'should not let javascript links pass through' do
+    # PoC from http://co3k.org/blog/redcloth-unfixed-xss-en
+    output = RedCloth.new('["clickme":javascript:alert(%27XSS%27)]', [:filter_html, :filter_styles, :filter_classes, :filter_ids]).to_html
+    expect(output).to_not match(/href=.javascript:alert/)
+  end
+
+
+end
